<?php
// $Id: b2es.functions.php,v 1.10 2003/05/05 20:21:19 cjc Exp $
//
// B2 Enhanced Search Form
// Copyright (C) 2003 Cheng-Jih Chen -- webmaster@cjc.org
//
// This is an add-on to b2 weblog / news publishing tool
// b2 is copyright (c)2001, 2002 by Michel Valdrighi - m@tidakada.com
//
// **********************************************************************
// Copyright (C) 2003 Cheng-Jih Chen
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// Cheng-Jih Chen (webmaster@cjc.org)
// *****************************************************************

################################################################################
#
# Some search-specific variables
#
################################################################################

$too_common_words = array(
  '1','2','3','4','5','6','7','8','9',
  'a', 'about', 'all', 'also', 'an', 'and', 'are', 'as', 'at',
  'be', 'because', 'been', 'but', 'by',
  'can',
  'didn', 'do', 'doesn',
  'else',
  'few', 'for', 'from',
  'get','go','got', 'goes',
  'had', 'has', 'have', 'he', 'here', 'his', 'how',
  'i', 'if', 'in', 'into', 'is', 'it', 'its',
  'like',
  'm', 'may','me','more', 'most', 'much', 'my',
  'no', 'not', 'now',
  'of', 'off', 'on', 'one', 'only', 'or', 'other', 'our', 'over',
  'put',
  're',
  's', 'since', 'should', 'so', 'some', 'such',
  't', 'than', 'that', 'the', 'there', 'their', 'them', 'then', 'these', 'they', 'this', 'though', 'through', 'to', 'too',
  'until','up',
  've', 'very',
  'was', 'we', 'were', 'what', 'when', 'where', 'which', 'while', 'who', 'why', 'will', 'with', 'would',
  'yet', 'you', 'your', 'yours'
);

$valid_characters = 'a-z0-9';

$table_searchterm = 'b2searchterm';
$table_concordance = 'b2concordance';

################################################################################
#
# b2es_process_post: add a given post to the search database
#
#   inputs: $post_id = ID of the post to add
#
#   output: status message
#
################################################################################

function b2es_process_post($postid) {

  if (!isset($postid) || $postid == '') return "You must specify a postID";

  $postdata = get_postdata($postid) ;

  if (count($postdata) == 0) return "Post $postid not found";

  $title = $postdata['Title'];
  $content = $postdata['Content'];

  $title_words = b2es_add_to_concordance($title, $postid, 2);
  $content_words = b2es_add_to_concordance($content, $postid, 1);

  return "$title_words words in title processed.  $content_words words in contents processed.";

}


################################################################################
#
# b2es_add_to_concordance: process a string
#
#   inputs: $content = input string
#           $score   = location-based score
#
#   output: number of words processed
#
################################################################################

function b2es_add_to_concordance($content, $postid, $score) {
  global $table_searchterm, $table_concordance, $too_common_words;

  $word_count = 0;
  $content = strip_tags($content);
  $content = strtolower($content);
  $content = preg_replace( '/[^a-z0-9]/', ' ', $content);

  $allwords = preg_split('/[\s]+/', $content);
  $allwords = array_unique($allwords);
  $allwords = array_diff($allwords, $too_common_words);

  if (count($allwords) == 0) return 0;
  if ($score == '') return 0;

  foreach ($allwords as $word) {
    if ($word != '') {
      $searchterm_ID = array();
      $searchterm_ID = b2es_get_searchtermID($word);
      if ($searchterm_ID[0] == 0) {
        $query = "INSERT INTO $table_searchterm(searchterm) VALUES ('$word')";
        $result = mysql_query($query) or mysql_oops($query);
        $searchterm_ID[0] = mysql_insert_id();
      }
      $query  = "INSERT INTO $table_concordance (searchterm_ID, post_ID, location_type) ";
      $query .= " VALUES( $searchterm_ID[0], $postid, $score )";
      $result = mysql_query($query) or mysql_oops($query);
      ++$word_count;
    }
  }
  return $word_count;
}


################################################################################
#
# b2es_get_searchtermID_wildcard: get the ID, if it exists, of a wildcard search term.
#                   If it doesn't exist, return 0
#
#   inputs: $searchterm = search term to locate in DB
#
#   output: searchterm_ID
#
################################################################################

function b2es_get_searchtermID_wildcard($searchterm) {
  global $table_searchterm;

  if (!isset($searchterm)) return(0);

  $searchterm = preg_replace('/\*/', '%', $searchterm);

  $query = "SELECT searchterm_ID FROM $table_searchterm WHERE searchterm like '$searchterm'";
  $result = mysql_query($query);
  if (!result) return(0);
  $row = mysql_fetch_row($result);
  return($row[0]);
}


################################################################################
#
# b2es_get_searchtermID: get the ID, if it exists, of a search term.  If it doesn't
#                   exist, return 0
#
#   inputs: $searchterm = search term to locate in DB
#
#   output: array of searchterm_IDs
#
################################################################################

function b2es_get_searchtermID($searchterm) {
  global $table_searchterm;
  $found_IDs = array();

  if (!isset($searchterm)) return(0);

  if (preg_match('/\*/', $searchterm)) {
    $matcher = 'LIKE';
    $searchterm = preg_replace('/\*/', '%', $searchterm);
  } else {
    $matcher = '=';
  }

  $query = "SELECT searchterm_ID FROM $table_searchterm WHERE searchterm $matcher '$searchterm'";
  $result = mysql_query($query);
  if (!result) return(0);
  while ($row = mysql_fetch_row($result)) {
    array_push($found_IDs, $row[0]);
  }
  return($found_IDs);
}


################################################################################
#
# b2es_get_postID: get the ID, if it exists, of posts given a search term ID
#
#   inputs: $searchterm_IDs = array of searchterm IDs
#
#   output: array $posts
#
################################################################################

function b2es_get_postID($searchterm_IDs) {
  global $table_concordance;

  $posts = array();

  if (count($searchterm_IDs) == 0) return(0);

  $searchterm_IDs_string = implode(',', $searchterm_IDs);

  $query = "SELECT DISTINCT post_id FROM $table_concordance WHERE searchterm_id IN ($searchterm_IDs_string)";
  $result = mysql_query($query) or mysql_oops($query);
  while ($row = mysql_fetch_row($result)) {
    array_push($posts, $row[0]);
  }
  return $posts;
}


################################################################################
#
# b2es_b2es_get_all_postID: get all postIDs in the database
#
#   inputs: none
#
#   output: array $posts
#
################################################################################

function b2es_get_all_postID() {
  global $tableposts;

  $posts = array();

  $query = "SELECT id FROM $tableposts ";
  $result = mysql_query($query);
  while ($row = mysql_fetch_row($result)) {
    array_push($posts, $row[0]);
  }
  return $posts;
}


################################################################################
#
# b2es_del_post_concordance: clean out a post_id from the concordance
#
#   inputs: $postid = post ID to clear
#
#   output: none
#
################################################################################

function b2es_del_post_concordance($postid) {
  global $table_concordance;

  if (!isset($postid) || $postid == '') return(0);

  $query = "DELETE FROM $table_concordance WHERE post_id = $postid";
  $result = mysql_query($query);
}

?>
