<?php
// $Id: b2search.php,v 1.24 2003/07/29 02:15:15 cjc Exp $
//
// B2 Enhanced Search Form
// Copyright (C) 2003 Cheng-Jih Chen -- webmaster@cjc.org
//
// This is an add-on to b2 weblog / news publishing tool
// b2 is copyright (c)2001, 2002 by Michel Valdrighi - m@tidakada.com
//
// **********************************************************************
// Copyright (C) 2003 Cheng-Jih Chen
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// Cheng-Jih Chen (webmaster@cjc.org)
// *****************************************************************

require ("b2config.php");
require_once ($b2inc.'/b2vars.php');
require_once ($b2inc.'/b2functions.php');
require_once ($b2inc.'/b2template.functions.php');
require_once ($b2inc.'/b2es.functions.php');

$b2varstoreset = array('s', 'sort', 'order', 'submit');

for ($i=0; $i<count($b2varstoreset); $i += 1) {
  $b2var = $b2varstoreset[$i];
  if (!isset($$b2var)) {
    if (empty($HTTP_POST_VARS[$b2var])) {
      if (empty($HTTP_GET_VARS[$b2var])) {
        $$b2var = '';
      } else {
        $$b2var = $HTTP_GET_VARS[$b2var];
      }
    } else {
      $$b2var = $HTTP_POST_VARS[$b2var];
    }
  }
}

$summary_word_count = 50;

$items_found = 0;

$db = mysql_connect($dbhost, $dbusername, $dbpassword) or die("Cannot connect to the database");
mysql_select_db($dbname) or die("Cannot select the database");

$s = strtolower($s);
$s = preg_replace( '/[^' . $valid_characters . '!|* ]/', ' ', $s);

$all_searchterms = preg_split('/[\s]+/', $s);

$common_words_found = array_intersect($too_common_words, $all_searchterms);
$all_searchterms = array_diff($all_searchterms, $too_common_words);


#
# Initialize an array of all postIDs and work with array intersections/diffs:
#

if (count($all_searchterms) != 0 && $submit == 'search') {
  $findable_posts = b2es_get_all_postID();
} else {
  $findable_posts = array();
}

$s = '';

foreach ($all_searchterms as $searchterm) {
  $current_posts = array();

  if ($searchterm != '' ) {
    if (substr($searchterm, 0, 1) == '!') {
      $not_flag = 1;
      $searchterm = substr($searchterm, 1);
    } else {
      $not_flag = 0;
    }

    $or_words = preg_split('/\|/', $searchterm);
    foreach ($or_words as $or_word) {
      $searchterm_IDs = b2es_get_searchtermID($or_word);
      $current_posts = array_merge($current_posts, b2es_get_postID($searchterm_IDs));
    }

    if (!$not_flag) {
      $findable_posts = array_intersect($findable_posts, $current_posts);
    } else {
      $findable_posts = array_diff($findable_posts, $current_posts);
    }
    $s .= $searchterm . ' ' ;
  }
}

$orderby_string = '';
switch ($sort) {
  case "title":
    $orderby_string = ' ORDER BY post_title';
    break;
  case "date":
    $orderby_string = ' ORDER BY post_date';
    break;
  case "author":
    $orderby_string = ' ORDER BY post_author';
    break;
  case "category":
    $orderby_string = ' ORDER BY post_category';
    break;
}

switch ($order) {
  case "a":
    $orderby_string .= ' ';
    break;
  case "d":
    $orderby_string .= ' DESC';
    break;
}

?>

<html>
<head><title>b2 Enhanced Search</title>
<link rel="stylesheet" href="layout2b.css" type="text/css">
<style>

.searchhelp {
  font:11px verdana, arial, helvetica, sans-serif;
}

hr {
  color:#DDDDDD;
}

</style>
</head>
<body>
<?php include($b2inc . '/searchhi.js'); ?>
<h2><?php bloginfo('name'); ?> b2 Search</h2>
<form action="<?php echo $siteurl . '/b2search.php' ?>">

<table width="65%">
<tr class="searchhelp">
<th width="10%"></th>
<th width="30%">Search term</th><th width="25%">Sorted By</th><th width="25%">Sort Order</th><th width="10%">&nbsp</th>
</tr>
<tr>
<td></td>
<td><center><input type="text" name="s" width="40" class="searchhelp" value="<?php echo $s ?>"></center></td>
<td><center>
<select name="sort" class="searchhelp">
  <option value="date" <?php if ($sort == 'date') print 'selected'; ?>>Date</option>
  <option value="title" <?php if ($sort == 'title') print 'selected'; ?>>Title</option>
  <option value="category" <?php if ($sort == 'category') print 'selected'; ?>>Category</option>
  <option value="author" <?php if ($sort == 'author') print 'selected'; ?>>Author</option>
</select>
</center></td>
<td class="searchhelp"><center>
<input type="radio" name="order" <?php if ($order == 'a' || $order == '') print 'CHECKED'; ?> value="a">Ascend<br>
<input type="radio" name="order" <?php if ($order == 'd') print 'CHECKED'; ?> value="d">Descend
</center></td>
<td><center>
<input type="hidden" name="submit" value="search">
<input type="submit" name="search" value="search" class="searchbutton">
</center></td>
</tr>
<tr>
<td></td>
<td colspan="4">
<center>

<table cellpadding="2">
<tr><td width="10%" valign="top" align="right" class="searchhelp">
<b>Help:</b>
</td><td class="searchhelp">
A boolean AND is assumed.<br>
Use | to indicate OR and ! to indicate NOT.<br>
Use * to indicate a wildcard match.  Regex is not supported.
</td><tr><td valign="top" align="right" class="searchhelp">

<b>Hint:</b>
</td><td class="searchhelp">
Put the NOT statements first.<br>
This search engine is not fuzzy: "dog" will not match "dogs".  Use wildcards for this: "dog*".
</td><tr><td valign="top" align="right" class="searchhelp">

<b>Examples:</b>
</td><td class="searchhelp">
"foo bar": posts with "foo" AND "bar".<br>
"foo*": posts with "foobar", "fooz", "food", etc.<br>
"foo|bar": posts with foo OR bar.<br>
"!foo": posts NOT containing "foo".<br>
"foo|bar baz": posts containing baz AND (foo OR bar).<br>
"!foo|bar baz": posts NOT containing "foo" OR "bar", AND containing "baz".<br>
</td></tr>

<?
if (is_array($common_words_found) && count($common_words_found) != 0) {
  print '<tr><td></td><td class="searchhelp">These words are too common and were not included in the search:<br>';
  foreach ($common_words_found as $word) {
    print '<b>' . $word . '</b> ';
  }
  print '</td><tr>';
}
?>

</table>

</center>
</td>
</tr>
</table>

</form>
</center>

<hr><center>
<table width="90%"><tr class="searchhelp">
<th width="10%">Date</th>
<th width="10%">Author</th>
<th width="10%">Category</th>
<th>Post</th></tr>

<?

$hilight_terms = implode("+", $all_searchterms);

if (is_array($findable_posts)) {
  $base_search_url = '<a href="' . $siteurl . '/' . $blogfilename . '?sh=' . $hilight_terms;
  $base_edit_url = '<a href="' . $siteurl . '/b2edit.php?action=edit';
  $post_string = implode(",", $findable_posts);
  if ($post_string != '') {
    $query  = "SELECT DISTINCT ID, post_title, post_date, post_author, post_category, ";
    $query .= " SUBSTRING_INDEX(post_content, ' ', $summary_word_count) post_summary ";
    $query .= " FROM $tableposts WHERE id IN ( $post_string )";
    $query .= $orderby_string;
    $result = mysql_query($query);

    get_currentuserinfo();

    while ($search_hit = mysql_fetch_row($result)) {
      $hit_id = stripslashes($search_hit[0]);
      $hit_title = stripslashes($search_hit[1]);
      $hit_date = mysql2date('Y-m-d', $search_hit[2]) ;
      $hit_author_id = $search_hit[3];
      $hit_category_id = $search_hit[4];
      $hit_summary = stripslashes($search_hit[5]);

      $hit_author_data = get_userdata($hit_author_id) ;
      $hit_category = get_catname($hit_category_id) ;
      $hit_author = $hit_author_data['user_nickname'];
      $hit_summary = strip_tags($hit_summary);

      if ($hit_title == '') { $hit_title = 'Click here to get to the post'; }

      print '<tr class="searchhelp"><td><center>' . $hit_date . '</td>';
      print '<td><center>' . $hit_author . '</td>';
      print '<td><center>' . $hit_category . '</td>';
      print '<td><div class="storyTitle">' . $base_search_url . '&p=' . $hit_id . '">' . $hit_title . '</a>';
      if ($user_level != 0) {
        print ' (' . $base_edit_url . '&post=' . $hit_id . '">Edit</a>)';
      }
      print '</div></td></tr>' . "\n";;
      print '<tr><td colspan="3"><td><div class="storyContent">' . $hit_summary . '... </div></td></tr>';

      ++$items_found;
    }
  }
}

?>

<tr><td>&nbsp;</td></tr>
<tr class="searchhelp"><td colspan="3"><center>
<b>Total Posts Found: <?php echo $items_found; ?></b><br>
</center></td></tr>
</table>
</font>
</body>
</html>
